diff --git a/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java b/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
index abba3832b..0109ada15 100644
--- a/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
+++ b/src/main/java/net/minecraft/core/net/command/helpers/BlockArgumentParser.java
@@ -9,13 +9,14 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.util.collection.NamespaceID;
 
 import java.util.concurrent.CompletableFuture;
 import java.util.function.Consumer;
 
 public class BlockArgumentParser extends ArgumentParser {
     private static final SimpleCommandExceptionType INVALID_BLOCK = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.block.invalid_block"));
-
+    public static final NamespaceID AIR_BLOCK = new NamespaceID("minecraft", "block/air");
     private Block block;
     private int metadata = 0;
     private CompoundTag tag = new CompoundTag();
@@ -51,15 +52,26 @@ public class BlockArgumentParser extends ArgumentParser {
     }
 
     private void parseBlock() throws CommandSyntaxException {
-        String string = this.reader.readString();
+        StringBuilder builder = new StringBuilder();
+        while (reader.canRead()) {
+            char peak = reader.peek();
+            if (peak == '[' || peak == '{' || peak == ' ') {
+                break;
+            }
+            builder.append(reader.read());
+        }
+        String string = builder.toString();
         boolean isAir = false;
-        for (Block blockInList : Block.blocksList) {
-            if (blockInList == null) continue;
-            if (CommandHelper.matchesKeyString(blockInList.getKey(), string)) {
-                this.block = blockInList;
-            } else if (CommandHelper.matchesKeyString("tile.air", string)) {
-                this.block = null;
-                isAir = true;
+        if (CommandHelper.matchesNamespaceId(AIR_BLOCK, string)) {
+            this.block = null;
+            isAir = true;
+        } else {
+            for (Block blockInList : Block.blocksList) {
+                if (blockInList == null) continue;
+                if (CommandHelper.matchesNamespaceId(blockInList.namespaceID, string)) {
+                    this.block = blockInList;
+                    break;
+                }
             }
         }
         if (this.block == null && !isAir) throw INVALID_BLOCK.createWithContext(this.reader);
diff --git a/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index 0d5d9d04c..b7b47d0a1 100644
--- a/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -11,7 +11,7 @@ public abstract class PacketHandler
 
     public abstract boolean isServerHandler();
 
-    public void handleMapChunk(BlockRegionUpdatePacket blockRegionUpdatePacket51Mapchunk)
+    public void handleMapChunk(BlockRegionUpdatePacket blockRegionUpdatePacket)
     {
     }
 
@@ -19,7 +19,7 @@ public abstract class PacketHandler
     {
     }
 
-    public void handleErrorMessage(String s, Object[] aobj)
+    public void handleErrorMessage(String message, Object[] objects)
     {
     }
 
@@ -38,29 +38,29 @@ public abstract class PacketHandler
         handleInvalidPacket(movePlayerPacket);
     }
 
-    public void handleMultiBlockChange(ChunkBlocksUpdatePacket packet)
+    public void handleMultiBlockChange(ChunkBlocksUpdatePacket chunkBlocksUpdatePacket)
     {
-        handleInvalidPacket(packet);
+        handleInvalidPacket(chunkBlocksUpdatePacket);
     }
 
-    public void handleBlockDig(PlayerActionPacket playerActionPacket14Blockdig)
+    public void handleBlockDig(PlayerActionPacket playerActionPacket)
     {
-        handleInvalidPacket(playerActionPacket14Blockdig);
+        handleInvalidPacket(playerActionPacket);
     }
 
-    public void handleBlockChange(BlockUpdatePacket blockchange)
+    public void handleBlockUpdate(BlockUpdatePacket blockUpdatePacket)
     {
-        handleInvalidPacket(blockchange);
+        handleInvalidPacket(blockUpdatePacket);
     }
 
-    public void handlePreChunk(ChunkVisibilityPacket packet50PrechunkVisibilityPacket)
+    public void handlePreChunk(ChunkVisibilityPacket chunkVisibilityPacket)
     {
-        handleInvalidPacket(packet50PrechunkVisibilityPacket);
+        handleInvalidPacket(chunkVisibilityPacket);
     }
 
-    public void handleNamedEntitySpawn(AddPlayerPacket addPlayerPacket20Namedentityspawn)
+    public void handleNamedEntitySpawn(AddPlayerPacket addPlayerPacket)
     {
-        handleInvalidPacket(addPlayerPacket20Namedentityspawn);
+        handleInvalidPacket(addPlayerPacket);
     }
 
     public void handleEntity(MoveEntityPacket moveEntityPacket)
@@ -68,9 +68,9 @@ public abstract class PacketHandler
         handleInvalidPacket(moveEntityPacket);
     }
 
-    public void handleEntityTeleport(TeleportEntityPacket packet34EntityteleportEntityPacket)
+    public void handleEntityTeleport(TeleportEntityPacket teleportEntityPacket)
     {
-        handleInvalidPacket(packet34EntityteleportEntityPacket);
+        handleInvalidPacket(teleportEntityPacket);
     }
 
     public void handlePlace(UseItemPacket useItemPacket)
@@ -78,24 +78,24 @@ public abstract class PacketHandler
         handleInvalidPacket(useItemPacket);
     }
 
-    public void handleBlockItemSwitch(SetCarriedItemPacket packet16blockitemswitch)
+    public void handleBlockItemSwitch(SetCarriedItemPacket setCarriedItemPacket)
     {
-        handleInvalidPacket(packet16blockitemswitch);
+        handleInvalidPacket(setCarriedItemPacket);
     }
 
-    public void handleDestroyEntity(RemoveEntityPacket packet29DestroyentityPacket)
+    public void handleDestroyEntity(RemoveEntityPacket removeEntityPacket)
     {
-        handleInvalidPacket(packet29DestroyentityPacket);
+        handleInvalidPacket(removeEntityPacket);
     }
 
-    public void handleSetPaintingMotive(SetPaintingArtPacket packet)
+    public void handleSetPaintingMotive(SetPaintingArtPacket setPaintingArtPacket)
     {
-        handleInvalidPacket(packet);
+        handleInvalidPacket(setPaintingArtPacket);
     }
 
-    public void handlePickupSpawn(AddItemEntityPacket addItemEntityPacket21Pickupspawn)
+    public void handlePickupSpawn(AddItemEntityPacket addItemEntityPacket)
     {
-        handleInvalidPacket(addItemEntityPacket21Pickupspawn);
+        handleInvalidPacket(addItemEntityPacket);
     }
 
     public void handleCollect(TakeItemEntityPacket takeItemEntityPacket)
@@ -108,9 +108,9 @@ public abstract class PacketHandler
         handleInvalidPacket(chatPacket);
     }
 
-    public void handleVehicleSpawn(AddEntityPacket addEntityPacket23Vehiclespawn)
+    public void handleVehicleSpawn(AddEntityPacket addEntityPacket)
     {
-        handleInvalidPacket(addEntityPacket23Vehiclespawn);
+        handleInvalidPacket(addEntityPacket);
     }
 
     public void handleAnimation(AnimatePacket animatePacket)
@@ -118,9 +118,9 @@ public abstract class PacketHandler
         handleInvalidPacket(animatePacket);
     }
 
-    public void handleEntityAction(PlayerCommandPacket packet19entityaction)
+    public void handlePlayerState(UpdatePlayerStatePacket updatePlayerStatePacket)
     {
-        handleInvalidPacket(packet19entityaction);
+        handleInvalidPacket(updatePlayerStatePacket);
     }
 
     public void handleHandshake(PreLoginPacket preLoginPacket)
@@ -128,54 +128,54 @@ public abstract class PacketHandler
         handleInvalidPacket(preLoginPacket);
     }
 
-    public void handleMobSpawn(AddMobPacket addMobspawn)
+    public void handleMobSpawn(AddMobPacket addMobPacket)
     {
-        handleInvalidPacket(addMobspawn);
+        handleInvalidPacket(addMobPacket);
     }
 
-    public void handleUpdateTime(SetTimePacket packet4UpdatetimePacket)
+    public void handleUpdateTime(SetTimePacket setTimePacket)
     {
-        handleInvalidPacket(packet4UpdatetimePacket);
+        handleInvalidPacket(setTimePacket);
     }
 
-    public void handleSpawnPosition(SetSpawnPositionPacket setSpawnpositionPacket)
+    public void handleSpawnPosition(SetSpawnPositionPacket setSpawnPositionPacket)
     {
-        handleInvalidPacket(setSpawnpositionPacket);
+        handleInvalidPacket(setSpawnPositionPacket);
     }
 
-    public void handleEntityVelocity(SetEntityMotionPacket setEntityvelocity)
+    public void handleEntityVelocity(SetEntityMotionPacket setEntityMotionPacket)
     {
-        handleInvalidPacket(setEntityvelocity);
+        handleInvalidPacket(setEntityMotionPacket);
     }
 
-    public void handleEntityMetadata(SetEntityDataPacket entitymetadata)
+    public void handleEntityMetadata(SetEntityDataPacket setEntityDataPacket)
     {
-        handleInvalidPacket(entitymetadata);
+        handleInvalidPacket(setEntityDataPacket);
     }
 
-    public void handleAttachEntity(SetRidingPacket setRidingPacket39Attachentity)
+    public void handleAttachEntity(SetRidingPacket setRidingPacket)
     {
-        handleInvalidPacket(setRidingPacket39Attachentity);
+        handleInvalidPacket(setRidingPacket);
     }
 
-    public void handleUseEntity(InteractPacket interactPacket7Useentity)
+    public void handleUseEntity(InteractPacket interactPacket)
     {
-        handleInvalidPacket(interactPacket7Useentity);
+        handleInvalidPacket(interactPacket);
     }
 
-    public void handleEntityStatus(EnitityEventPacket enitityEventPacket38Entitystatus)
+    public void handleEntityStatus(EnitityEventPacket enitityEventPacket)
     {
-        handleInvalidPacket(enitityEventPacket38Entitystatus);
+        handleInvalidPacket(enitityEventPacket);
     }
 
-    public void handleEntityTagData(EntityTagDataPacket packet)
+    public void handleEntityTagData(EntityTagDataPacket entityTagDataPacket)
     {
-        handleInvalidPacket(packet);
+        handleInvalidPacket(entityTagDataPacket);
     }
 
-    public void handleUpdateHealth(SetHealthPacket packet8UpdatehealthPacket)
+    public void handleUpdateHealth(SetHealthPacket setHealthPacket)
     {
-        handleInvalidPacket(packet8UpdatehealthPacket);
+        handleInvalidPacket(setHealthPacket);
     }
 
     public void handleUpdatePlayerProfile(UpdatePlayerProfilePacket updatePlayerProfilePacket)
@@ -193,24 +193,24 @@ public abstract class PacketHandler
         handleInvalidPacket(explosionPacket);
     }
 
-    public void handleOpenWindow(ContainerOpenPacket containerOpenwindow)
+    public void handleOpenWindow(ContainerOpenPacket containerOpenPacket)
     {
-        handleInvalidPacket(containerOpenwindow);
+        handleInvalidPacket(containerOpenPacket);
     }
 
-    public void handleCloseWindow(ContainerClosePacket containerClosewindow)
+    public void handleCloseWindow(ContainerClosePacket containerClosePacket)
     {
-        handleInvalidPacket(containerClosewindow);
+        handleInvalidPacket(containerClosePacket);
     }
 
-    public void handleWindowClick(ContainerClickPacket packet102WindowclickPacket)
+    public void handleWindowClick(ContainerClickPacket containerClickPacket)
     {
-        handleInvalidPacket(packet102WindowclickPacket);
+        handleInvalidPacket(containerClickPacket);
     }
 
-    public void handleTileEntityData(BlockEntityDataPacket packet)
+    public void handleTileEntityData(BlockEntityDataPacket blockEntityDataPacket)
     {
-        handleInvalidPacket(packet);
+        handleInvalidPacket(blockEntityDataPacket);
     }
 
     public void handleSetSlot(ContainerSetSlotPacket containerSetslotPacket)
@@ -218,14 +218,14 @@ public abstract class PacketHandler
         handleInvalidPacket(containerSetslotPacket);
     }
 
-    public void handleWindowItems(ContainerSetContentPacket containerSetContentPacket104Windowitems)
+    public void handleWindowItems(ContainerSetContentPacket containerSetContentPacket)
     {
-        handleInvalidPacket(containerSetContentPacket104Windowitems);
+        handleInvalidPacket(containerSetContentPacket);
     }
 
-    public void handleUpdateSign(SignUpdatePacket packet130UpdatesignUpdatePacket)
+    public void handleUpdateSign(SignUpdatePacket signUpdatePacket)
     {
-        handleInvalidPacket(packet130UpdatesignUpdatePacket);
+        handleInvalidPacket(signUpdatePacket);
     }
 
     public void handleSetMobSpawner(SetMobSpawnerPacket setMobSpawnerPacket)
@@ -233,14 +233,14 @@ public abstract class PacketHandler
         handleInvalidPacket(setMobSpawnerPacket);
     }
     
-    public void handleUpdateProgressbar(ContainerSetDataPacket containerSetDataPacket105Updateprogressbar)
+    public void handleUpdateProgressbar(ContainerSetDataPacket containerSetDataPacket)
     {
-        handleInvalidPacket(containerSetDataPacket105Updateprogressbar);
+        handleInvalidPacket(containerSetDataPacket);
     }
 
-    public void handlePlayerInventory(SetEquippedItemPacket setEquippedItemPacket5Playerinventory)
+    public void handlePlayerInventory(SetEquippedItemPacket setEquippedItemPacket)
     {
-        handleInvalidPacket(setEquippedItemPacket5Playerinventory);
+        handleInvalidPacket(setEquippedItemPacket);
     }
 
     public void handlePlayerHeldObject(SetHeldObjectPacket setHeldObjectPacket) {
@@ -252,18 +252,18 @@ public abstract class PacketHandler
         handleInvalidPacket(containerAckPacket);
     }
 
-    public void handleEntityPainting(AddPaintingPacket packet25EntitypaintingPacket)
+    public void handleEntityPainting(AddPaintingPacket addPaintingPacket)
     {
-        handleInvalidPacket(packet25EntitypaintingPacket);
+        handleInvalidPacket(addPaintingPacket);
     }
     public void handleBoatControl(BoatControlPacket boatControlPacket)
     {
         handleInvalidPacket(boatControlPacket);
     }
 
-    public void handlePlayNoteBlock(BlockEventPacket packet54PlaynoteblockEventPacket)
+    public void handleBlockEvent(BlockEventPacket blockEventPacket)
     {
-        handleInvalidPacket(packet54PlaynoteblockEventPacket);
+        handleInvalidPacket(blockEventPacket);
     }
 
     public void handleStatistic(StatisticPacket statisticPacket)
@@ -290,9 +290,9 @@ public abstract class PacketHandler
         handleInvalidPacket(mapdataPacket);
     }
 
-    public void handlePlaySoundEffect(PlaySoundEffectPacket packet61doorchange)
+    public void handlePlaySoundEffect(PlaySoundEffectPacket playSoundEffectPacket)
     {
-        handleInvalidPacket(packet61doorchange);
+        handleInvalidPacket(playSoundEffectPacket);
     }
     public void handlePlaySoundDirectly(PlaySoundEffectDirectPacket playSoundEffectDirectPacket)
     {
@@ -347,18 +347,18 @@ public abstract class PacketHandler
         handleInvalidPacket(playerListPacket);
     }
 
-    public void handleOpenFlagWindow(FlagOpenPacket packet)
+    public void handleOpenFlagWindow(FlagOpenPacket flagOpenPacket)
     {
-        handleInvalidPacket(packet);
+        handleInvalidPacket(flagOpenPacket);
     }
 
-    public void handlePhotoMode(PhotoModePacket packet)
+    public void handlePhotoMode(PhotoModePacket photoModePacket)
     {
-        handleInvalidPacket(packet);
+        handleInvalidPacket(photoModePacket);
     }
 
-    public void handlePingHandshake(PingHandshakePacket packet) {
-        handleInvalidPacket(packet);
+    public void handlePingHandshake(PingHandshakePacket pingHandshakePacket) {
+        handleInvalidPacket(pingHandshakePacket);
     }
 
     public void handleGameRule(GameRulePacket gameRulePacket) {
@@ -369,19 +369,19 @@ public abstract class PacketHandler
         handleInvalidPacket(recipeSyncPacket);
     }
     
-    public void handleIds(SyncIDsPacket packet) {
-    	handleInvalidPacket(packet);
+    public void handleIds(SyncIDsPacket syncIDsPacket) {
+    	handleInvalidPacket(syncIDsPacket);
     }
     
-    public void handleCustomPayload(CustomPayloadPacket packet) {
-    	handleInvalidPacket(packet);
+    public void handleCustomPayload(CustomPayloadPacket customPayloadPacket) {
+    	handleInvalidPacket(customPayloadPacket);
     }
 
-    public void handleCommandManagerPacket(CommandManagerPacket packet) {
-        handleInvalidPacket(packet);
+    public void handleCommandManagerPacket(CommandManagerPacket commandManagerPacket) {
+        handleInvalidPacket(commandManagerPacket);
     }
 
-    public void handleRequestCommandManagerPacket(RequestCommandManagerPacket packet) {
-        handleInvalidPacket(packet);
+    public void handleRequestCommandManagerPacket(RequestCommandManagerPacket requestCommandManagerPacket) {
+        handleInvalidPacket(requestCommandManagerPacket);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/BlockEventPacket.java b/src/main/java/net/minecraft/core/net/packet/BlockEventPacket.java
index 9bb9a2cad..6924123c4 100644
--- a/src/main/java/net/minecraft/core/net/packet/BlockEventPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/BlockEventPacket.java
@@ -9,18 +9,23 @@ import java.io.*;
 
 public class BlockEventPacket extends Packet
 {
+    public int xLocation;
+    public int yLocation;
+    public int zLocation;
+    public int index;
+    public int data;
 
     public BlockEventPacket()
     {
     }
-    
-    public BlockEventPacket(int i, int j, int k, int l, int i1)
+
+    public BlockEventPacket(int x, int y, int z, int index, int data)
     {
-        xLocation = i;
-        yLocation = j;
-        zLocation = k;
-        instrumentType = l;
-        pitch = i1;
+        xLocation = x;
+        yLocation = y;
+        zLocation = z;
+        this.index = index;
+        this.data = data;
     }
 
     @Override
@@ -30,8 +35,8 @@ public class BlockEventPacket extends Packet
         xLocation = dis.readInt();
         yLocation = dis.readShort();
         zLocation = dis.readInt();
-        instrumentType = dis.read();
-        pitch = dis.read();
+        index = dis.read();
+        data = dis.read();
     }
 
     @Override
@@ -41,14 +46,14 @@ public class BlockEventPacket extends Packet
         dos.writeInt(xLocation);
         dos.writeShort(yLocation);
         dos.writeInt(zLocation);
-        dos.write(instrumentType);
-        dos.write(pitch);
+        dos.write(index);
+        dos.write(data);
     }
 
     @Override
 	public void handlePacket(PacketHandler packetHandler)
     {
-        packetHandler.handlePlayNoteBlock(this);
+        packetHandler.handleBlockEvent(this);
     }
 
     @Override
@@ -56,10 +61,4 @@ public class BlockEventPacket extends Packet
     {
         return 12;
     }
-
-    public int xLocation;
-    public int yLocation;
-    public int zLocation;
-    public int instrumentType;
-    public int pitch;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/BlockUpdatePacket.java b/src/main/java/net/minecraft/core/net/packet/BlockUpdatePacket.java
index e98e62071..bd62caaf4 100644
--- a/src/main/java/net/minecraft/core/net/packet/BlockUpdatePacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/BlockUpdatePacket.java
@@ -10,20 +10,26 @@ import java.io.*;
 
 public class BlockUpdatePacket extends Packet
 {
+    public int xPosition;
+    public int yPosition;
+    public int zPosition;
+    public int blockId;
+    public int metadata;
+
 
     public BlockUpdatePacket()
     {
         isChunkDataPacket = true;
     }
-    
-    public BlockUpdatePacket(int i, int j, int k, World world)
+
+    public BlockUpdatePacket(int x, int y, int z, World world)
     {
         isChunkDataPacket = true;
-        xPosition = i;
-        yPosition = j;
-        zPosition = k;
-        type = world.getBlockId(i, j, k);
-        metadata = world.getBlockMetadata(i, j, k);
+        xPosition = x;
+        yPosition = y;
+        zPosition = z;
+        blockId = world.getBlockId(x, y, z);
+        metadata = world.getBlockMetadata(x, y, z);
     }
 
     @Override
@@ -33,7 +39,7 @@ public class BlockUpdatePacket extends Packet
         xPosition = dis.readInt();
         yPosition = dis.readShort();
         zPosition = dis.readInt();
-        type = dis.readShort();
+        blockId = dis.readShort();
         metadata = dis.read();
     }
 
@@ -44,14 +50,14 @@ public class BlockUpdatePacket extends Packet
         dos.writeInt(xPosition);
         dos.writeShort(yPosition);
         dos.writeInt(zPosition);
-        dos.writeShort(type);
+        dos.writeShort(blockId);
         dos.write(metadata);
     }
 
     @Override
 	public void handlePacket(PacketHandler packetHandler)
     {
-        packetHandler.handleBlockChange(this);
+        packetHandler.handleBlockUpdate(this);
     }
 
     @Override
@@ -59,10 +65,4 @@ public class BlockUpdatePacket extends Packet
     {
         return 11;
     }
-
-    public int xPosition;
-    public int yPosition;
-    public int zPosition;
-    public int type;
-    public int metadata;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/ChunkVisibilityPacket.java b/src/main/java/net/minecraft/core/net/packet/ChunkVisibilityPacket.java
index 6521a39ef..2741cbe9c 100644
--- a/src/main/java/net/minecraft/core/net/packet/ChunkVisibilityPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/ChunkVisibilityPacket.java
@@ -9,36 +9,39 @@ import java.io.*;
 
 public class ChunkVisibilityPacket extends Packet
 {
+    public int chunkX;
+    public int chunkZ;
+    public boolean playerAdded;
 
     public ChunkVisibilityPacket()
     {
         isChunkDataPacket = false;
     }
     
-    public ChunkVisibilityPacket(int i, int j, boolean flag)
+    public ChunkVisibilityPacket(int chunkX, int chunkZ, boolean playerAdded)
     {
         isChunkDataPacket = false;
-        xPosition = i;
-        yPosition = j;
-        mode = flag;
+        this.chunkX = chunkX;
+        this.chunkZ = chunkZ;
+        this.playerAdded = playerAdded;
     }
 
     @Override
 	public void read(DataInputStream dis)
         throws IOException
     {
-        xPosition = dis.readInt();
-        yPosition = dis.readInt();
-        mode = dis.read() != 0;
+        chunkX = dis.readInt();
+        chunkZ = dis.readInt();
+        playerAdded = dis.read() != 0;
     }
 
     @Override
 	public void write(DataOutputStream dos)
         throws IOException
     {
-        dos.writeInt(xPosition);
-        dos.writeInt(yPosition);
-        dos.write(mode ? 1 : 0);
+        dos.writeInt(chunkX);
+        dos.writeInt(chunkZ);
+        dos.write(playerAdded ? 1 : 0);
     }
 
     @Override
@@ -52,8 +55,4 @@ public class ChunkVisibilityPacket extends Packet
     {
         return 9;
     }
-
-    public int xPosition;
-    public int yPosition;
-    public boolean mode;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/MovePlayerPacket.java b/src/main/java/net/minecraft/core/net/packet/MovePlayerPacket.java
index 33765f9d1..5bda6e6ed 100644
--- a/src/main/java/net/minecraft/core/net/packet/MovePlayerPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/MovePlayerPacket.java
@@ -12,7 +12,6 @@ public class MovePlayerPacket extends Packet
     public double x;
     public double y;
     public double z;
-    public double yView;
     public float yaw;
     public float pitch;
     public boolean onGround;
@@ -92,10 +91,9 @@ public class MovePlayerPacket extends Packet
             this.hasPosition = true;
         }
 
-        public Pos(final double x, final double y, final double yView, final double z, final boolean onGround) {
+        public Pos(final double x, final double y, final double z, final boolean onGround) {
             this.x = x;
             this.y = y;
-            this.yView = yView;
             this.z = z;
             this.onGround = onGround;
             this.hasPosition = true;
@@ -105,7 +103,6 @@ public class MovePlayerPacket extends Packet
         public void read(final DataInputStream dataInputStream) throws IOException {
             this.x = dataInputStream.readDouble();
             this.y = dataInputStream.readDouble();
-            this.yView = dataInputStream.readDouble();
             this.z = dataInputStream.readDouble();
             super.read(dataInputStream);
         }
@@ -114,7 +111,6 @@ public class MovePlayerPacket extends Packet
         public void write(final DataOutputStream dataOutputStream) throws IOException {
             dataOutputStream.writeDouble(this.x);
             dataOutputStream.writeDouble(this.y);
-            dataOutputStream.writeDouble(this.yView);
             dataOutputStream.writeDouble(this.z);
             super.write(dataOutputStream);
         }
@@ -132,10 +128,9 @@ public class MovePlayerPacket extends Packet
             this.hasPosition = true;
         }
 
-        public PosRot(final double x, final double y, final double yView, final double z, final float yaw, final float pitch, final boolean onGround) {
+        public PosRot(final double x, final double y, final double z, final float yaw, final float pitch, final boolean onGround) {
             this.x = x;
             this.y = y;
-            this.yView = yView;
             this.z = z;
             this.yaw = yaw;
             this.pitch = pitch;
@@ -148,7 +143,6 @@ public class MovePlayerPacket extends Packet
         public void read(final DataInputStream dataInputStream) throws IOException {
             this.x = dataInputStream.readDouble();
             this.y = dataInputStream.readDouble();
-            this.yView = dataInputStream.readDouble();
             this.z = dataInputStream.readDouble();
             this.yaw = dataInputStream.readFloat();
             this.pitch = dataInputStream.readFloat();
@@ -159,7 +153,6 @@ public class MovePlayerPacket extends Packet
         public void write(final DataOutputStream dataOutputStream) throws IOException {
             dataOutputStream.writeDouble(this.x);
             dataOutputStream.writeDouble(this.y);
-            dataOutputStream.writeDouble(this.yView);
             dataOutputStream.writeDouble(this.z);
             dataOutputStream.writeFloat(this.yaw);
             dataOutputStream.writeFloat(this.pitch);
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet.java b/src/main/java/net/minecraft/core/net/packet/Packet.java
index c7686ea16..6938b9216 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -271,7 +271,7 @@ public abstract class Packet
         addMapping(16, true, true, SetCarriedItemPacket.class);
         addMapping(17, true, false, SleepPacket.class);
         addMapping(18, true, true, AnimatePacket.class);
-        addMapping(19, false, true, PlayerCommandPacket.class);
+        addMapping(19, false, true, UpdatePlayerStatePacket.class);
         addMapping(20, true, false, AddPlayerPacket.class);
         addMapping(21, true, false, AddItemEntityPacket.class);
         addMapping(22, true, false, TakeItemEntityPacket.class);
diff --git a/src/main/java/net/minecraft/core/net/packet/PlayerActionPacket.java b/src/main/java/net/minecraft/core/net/packet/PlayerActionPacket.java
index 5edc6d209..49c8368f3 100644
--- a/src/main/java/net/minecraft/core/net/packet/PlayerActionPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/PlayerActionPacket.java
@@ -12,17 +12,33 @@ import net.minecraft.core.util.helper.Side;
 
 public class PlayerActionPacket extends Packet
 {
+    public static final int ACTION_DIG_START = 0;
+    public static final int ACTION_DIG_CONTINUED = 1;
+    public static final int ACTION_DIG_COMPLETE = 2;
+
+    public static final int ACTION_DROP_ITEM_SINGLE = 4;
+    public static final int ACTION_DROP_ITEM_STACK = 5;
+    public static final int ACTION_PICK_BLOCK = 6;
+
+    public int xPosition;
+    public int yPosition;
+    public int zPosition;
+    public Side side;
+    public double xHit;
+    public double yHit;
+    public int action;
+
 
     public PlayerActionPacket()
     {
     }
 
-    public PlayerActionPacket(int i, int j, int k, int l, Side side, double xHit, double yHit)
+    public PlayerActionPacket(int action, int x, int y, int z, Side side, double xHit, double yHit)
     {
-        status = i;
-        xPosition = j;
-        yPosition = k;
-        zPosition = l;
+        this.action = action;
+        xPosition = x;
+        yPosition = y;
+        zPosition = z;
         this.side = side;
         this.xHit = xHit;
         this.yHit = yHit;
@@ -32,7 +48,7 @@ public class PlayerActionPacket extends Packet
 	public void read(DataInputStream dis)
         throws IOException
     {
-        status = dis.read();
+        action = dis.read();
         xPosition = dis.readInt();
         yPosition = dis.read();
         zPosition = dis.readInt();
@@ -45,7 +61,7 @@ public class PlayerActionPacket extends Packet
 	public void write(DataOutputStream dos)
         throws IOException
     {
-        dos.write(status);
+        dos.write(action);
         dos.writeInt(xPosition);
         dos.write(yPosition);
         dos.writeInt(zPosition);
@@ -65,12 +81,4 @@ public class PlayerActionPacket extends Packet
     {
         return 19;
     }
-
-    public int xPosition;
-    public int yPosition;
-    public int zPosition;
-    public Side side;
-    public double xHit;
-    public double yHit;
-    public int status;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/PlayerCommandPacket.java b/src/main/java/net/minecraft/core/net/packet/UpdatePlayerStatePacket.java
similarity index 63%
rename from src/main/java/net/minecraft/core/net/packet/PlayerCommandPacket.java
rename to src/main/java/net/minecraft/core/net/packet/UpdatePlayerStatePacket.java
index 03dfce762..9e89c21ad 100644
--- a/src/main/java/net/minecraft/core/net/packet/PlayerCommandPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/UpdatePlayerStatePacket.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
@@ -8,24 +7,26 @@ import java.io.*;
 // Referenced classes of package net.minecraft.src:
 //            Packet, Entity, PacketHandler
 
-public class PlayerCommandPacket extends Packet
+public class UpdatePlayerStatePacket extends Packet
 {
+    public static final int STATE_SNEAK = 1;
+    public static final int STATE_UN_SNEAK = 2;
+    public static final int STATE_LEAVE_BED = 3;
+    public int state;
 
-    public PlayerCommandPacket()
+    public UpdatePlayerStatePacket()
     {
     }
 
-    public PlayerCommandPacket(Entity entity, int i)
+    public UpdatePlayerStatePacket(int state)
     {
-        entityId = entity.id;
-        state = i;
+        this.state = state;
     }
 
     @Override
 	public void read(DataInputStream dis)
         throws IOException
     {
-        entityId = dis.readInt();
         state = dis.readByte();
     }
 
@@ -33,22 +34,19 @@ public class PlayerCommandPacket extends Packet
 	public void write(DataOutputStream dos)
         throws IOException
     {
-        dos.writeInt(entityId);
         dos.writeByte(state);
     }
 
     @Override
 	public void handlePacket(PacketHandler packetHandler)
     {
-        packetHandler.handleEntityAction(this);
+        packetHandler.handlePlayerState(this);
     }
 
     @Override
 	public int getEstimatedSize()
     {
-        return 5;
+        return 1;
     }
 
-    public int entityId;
-    public int state;
 }
